/*
 * Copyright 2008-2009 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMODRTREE_BASEOBJECTMODEL
#define SIGMODRTREE_BASEOBJECTMODEL

// Sigmodr tree includes
#include "BaseModel.h"

namespace Sigmodr
{
namespace Tree
{
class SIGMODRTREE_NO_EXPORT BaseObjectModel : public BaseModel
{
    Q_OBJECT
    
    public:
        BaseObjectModel(BaseModel* parent, Sigmod::Object* object);
        virtual ~BaseObjectModel();
        
        virtual QVariant data(int role = Qt::DisplayRole) const;
        virtual int rowCount() const = 0;
        
        Qt::ItemFlags flags() const;
        virtual bool setData(const QVariant& value, int role = Qt::EditRole) = 0;
        
        virtual BaseModel* childItem(const int row) = 0;
        
        Qt::DropActions supportedDragActions() const;
        Qt::DropActions supportedDropActions() const;
        
        QString type() const;
        virtual QString types() const = 0;
    protected:
        virtual int findChild(BaseModel* model) const;
};
}
}

#endif
