/*
 * Copyright 2008-2009 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMODRTREE_GAMEMODEL
#define SIGMODRTREE_GAMEMODEL

// Sigmodr tree includes
#include "GroupObjectModel.h"

// Forward declarations
namespace Sigmod
{
class Game;
}

namespace Sigmodr
{
namespace Tree
{
class SIGMODRTREE_NO_EXPORT GameModel : public GroupObjectModel
{
    Q_OBJECT
    
    public:
        GameModel(BaseModel* parent, Sigmod::Game* game);
        ~GameModel();
        
        QVariant data(int role = Qt::DisplayRole) const;
        
        bool setData(const QVariant& value, int role = Qt::EditRole);
        
        QString types() const;
    public slots:
        void addObject(Sigmod::Object* object = NULL);
        void deleteObject(BaseModel* model);
        
        void deleteSelf();
    protected:
        void setupData();
};
}
}

#endif
