/*
 * Copyright 2008-2009 Ben Boeckel <MathStuf@gmail.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SIGMODRTREE_GROUPOBJECTMODEL
#define SIGMODRTREE_GROUPOBJECTMODEL

// Sigmodr tree includes
#include "BaseObjectModel.h"
#include "Grouping.h"

namespace Sigmodr
{
namespace Tree
{
class SIGMODRTREE_NO_EXPORT GroupObjectModel : public BaseObjectModel, public Grouping
{
    Q_OBJECT
    
    public:
        GroupObjectModel(BaseModel* parent, Sigmod::Object* object);
        virtual ~GroupObjectModel();
        
        virtual QVariant data(int role = Qt::DisplayRole) const;
        int rowCount() const;
        
        virtual bool setData(const QVariant& value, int role = Qt::EditRole) = 0;
        
        BaseModel* childItem(const int row);
        
        virtual QString types() const = 0;
    public slots:
        void addChild(BaseModel* model);
        
        virtual void addObject(Sigmod::Object* object = NULL) = 0;
        virtual void deleteObject(BaseModel* model) = 0;
        
        virtual void deleteSelf() = 0;
    protected:
        int findChild(BaseModel* model) const;
        
        virtual void setupData() = 0;
};
}
}

#endif
